<!-- Nav -->
<%- include('../partials/nav', {active: "vault"}); %>

<div class="container-fluid">
    <div class="row d-flex d-md-block flex-nowrap wrapper">
        <main class="col-12 float-left col px-5 px-md-3 py-3 main">
            <h1>
                Edit Secret
            </h1>
            <% include ../partials/messages %>
            <form action="/vault/kv/secret/edit" method="POST" enctype="application/json">

                <div class="form-group">

                    <div class="form-row mb-2">
                        <div class="col">
                            <label for="pathInput" class="font-weight-bold">Path</label>
                            <input id="pathInput" type="text" class="form-control" placeholder="Path" name="vaultPath" value="<%=vaultPath%>" required readonly>
                        </div>
                    </div>

                    <hr/>

                    <div class="form-row mb-2">
                        <table class="table table-striped table-sm">
                            <thead>
                                <tr>
                                    <th colspan="3">
                                        Secret data
                                    </th>
                                </tr>
                            </thead>
                            <tbody>
                                <% Object.keys(secretData).concat([null,null,null,null]).forEach((key,i) => { %>
                                    <tr id="tableRow<%=i%>">
                                        <td>
                                            <input id="secretKey<%=i%>" type="text" class="form-control" placeholder="key"
                                                name="secretData[<%=i%>][key]"
                                                value="<%=key%>">
                                        </td>
                                        <td>
                                            <div class="input-group">
                                                <input id="secretValue<%=i%>" type="password" class="form-control" placeholder="value"
                                                    name="secretData[<%=i%>][value]" value="<%=secretData[key]%>"
                                                    onfocus="togglePasswordInputVisibility('<%=i%>')"
                                                    onblur="togglePasswordInputVisibility('<%=i%>')">
                                            
                                                <% if (key) { %>
                                                    <div class="input-group-append">
                                                        <button id="secretValue<%=i%>_toggleBtn" class="btn btn-outline-secondary" type="button"
                                                            onclick="togglePasswordInputVisibility('<%=i%>')"><i class="fas fa-eye"></i></button>
                                                    </div>
                                                <%} %>
                                            </div>
                                        </td>
                                        <td style="width: 50px;">
                                            <% if (key) { %>
                                                <button id="secret<%=i%>_clearBtn" class="btn btn-outline-secondary" type="button" onclick="clearInput('<%=i%>')"><i
                                                        class="fas fa-trash-alt"></i></button>
                                            <%} %>
                                        </td>
                                    </tr>
                                <%}) %>
                            </tbody>
                        </table>
                    </div>

                </div>
                <div>
                    <button type="submit" class="btn btn-primary">Save</button>
                    <a class="btn btn-secondary" href="/vault/kv/secret/read/<%=encodeURIComponent(vaultPath)%>">Back</a>
                </div>
            </form>
        </main>
    </div>
</div>

<script>

    function togglePasswordInputVisibility(rowIndex) {
        const inputElement = document.getElementById(`secretValue${rowIndex}`);
        const toggleBtnElement = document.getElementById(`secretValue${rowIndex}_toggleBtn`);
        console.log(inputElement);
        console.log(toggleBtnElement);
        if (inputElement.type === "password") {
            inputElement.type = "text";
            toggleBtnElement.innerHTML = '<i class="fas fa-eye-slash"></i>';
        }
        else if (inputElement.type === "text") {
            inputElement.type = "password";
            toggleBtnElement.innerHTML = '<i class="fas fa-eye"></i>';
        }
    }

    function clearInput(rowIndex) {
        const secretKeyInputElement = document.getElementById(`secretKey${rowIndex}`);
        const secretValueInputElement = document.getElementById(`secretValue${rowIndex}`);
        const tableRowElement = document.getElementById(`tableRow${rowIndex}`);
        secretKeyInputElement.value = null;
        secretValueInputElement.value = null;
        tableRowElement.outerHTML = null;
    }

</script>